Package io.vertx.reactivex.ext.web.handler.sockjs

## Class SockJSSocket

- java.lang.Object
- - io.vertx.reactivex.ext.web.handler.sockjs.SockJSSocket

- All Implemented Interfaces:
    `io.vertx.lang.rx.RxDelegate`, `ReadStream<Buffer>`, `StreamBase`, `WriteStream<Buffer>`

      public class SockJSSocket
      extends Object
      implements io.vertx.lang.rx.RxDelegate, ReadStream<Buffer>, WriteStream<Buffer>

  You interact with SockJS clients through instances of SockJS socket.

  The API is very similar to `WebSocket`. It implements both and so it can be used with to pump data with flow control.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<SockJSSocket>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SockJSSocket​(SockJSSocket delegate)` |
    `SockJSSocket​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close it
    `void` | `close​(int statusCode, String reason)` | Close it giving a status code and reason.
    `SockJSSocket` | `closeHandler​(Handler<Void> closeHandler)` |
    `SockJSSocket` | `drainHandler​(Handler<Void> handler)` | Set a drain handler on the stream.
    `Future<Void>` | `end()` | Call `close()`.
    `Future<Void>` | `end​(Buffer data)` | Same as `end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
    `SockJSSocket` | `endHandler​(Handler<Void> endHandler)` | Set an end handler.
    `boolean` | `equals​(Object o)` |
    `SockJSSocket` | `exceptionHandler​(Handler<Throwable> handler)` | Set an exception handler on the read stream.
    `SockJSSocket` | `fetch​(long amount)` | Fetch the specified `amount` of elements.
    `SockJSSocket` | `getDelegate()` |
    `SockJSSocket` | `handler​(Handler<Buffer> handler)` | Set a data handler.
    `int` | `hashCode()` |
    `MultiMap` | `headers()` | Return the headers corresponding to the last request for this socket or the websocket handshake Any cookie headers will be removed for security reasons
    `SocketAddress` | `localAddress()` | Return the local address for this socket
    `static SockJSSocket` | `newInstance​(SockJSSocket arg)` |
    `SockJSSocket` | `pause()` | Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `Pipe<Buffer>` | `pipe()` | Pause this stream and return a to transfer the elements of this stream to a destination .
    `Future<Void>` | `pipeTo​(WriteStream<Buffer> dst)` | Pipe this `ReadStream` to the `WriteStream`.
    `SocketAddress` | `remoteAddress()` | Return the remote address for this socket
    `SockJSSocket` | `resume()` | Resume reading, and sets the buffer in `flowing` mode.
    `RoutingContext` | `routingContext()` |
    `Completable` | `rxEnd()` | Call `close()`.
    `Completable` | `rxEnd​(Buffer data)` | Same as `end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
    `Completable` | `rxPipeTo​(WriteStream<Buffer> dst)` | Pipe this `ReadStream` to the `WriteStream`.
    `Completable` | `rxWrite​(Buffer data)` | Write some data to the stream.
    `Completable` | `rxWrite​(String data)` | Write a `String` to the socket, encoded in UTF-8.
    `SockJSSocket` | `setWriteQueueMaxSize​(int maxSize)` | Set the maximum size of the write queue to `maxSize`.
    `Flowable<Buffer>` | `toFlowable()` |
    `Observable<Buffer>` | `toObservable()` |
    `WriteStreamObserver<Buffer>` | `toObserver()` |
    `String` | `toString()` |
    `WriteStreamSubscriber<Buffer>` | `toSubscriber()` |
    `String` | `uri()` | Return the URI corresponding to the last request for this socket or the websocket handshake
    `Session` | `webSession()` |
    `User` | `webUser()` |
    `Future<Void>` | `write​(Buffer data)` | Write some data to the stream.
    `Future<Void>` | `write​(String data)` | Write a `String` to the socket, encoded in UTF-8.
    `String` | `writeHandlerID()` | When a `SockJSSocket` is created it can register an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.
    `boolean` | `writeQueueFull()` | This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<SockJSSocket> __TYPE_ARG

  - ### Constructor Detail

    - #### SockJSSocket

          public SockJSSocket​(SockJSSocket delegate)

    - #### SockJSSocket

          public SockJSSocket​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public SockJSSocket getDelegate()

      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `io.vertx.lang.rx.RxDelegate`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### toObservable

          public Observable<Buffer> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<Buffer>`

    - #### toFlowable

          public Flowable<Buffer> toFlowable()

      Specified by:
        `toFlowable` in interface `ReadStream<Buffer>`

    - #### toObserver

          public WriteStreamObserver<Buffer> toObserver()

      Specified by:
        `toObserver` in interface `WriteStream<Buffer>`

    - #### toSubscriber

          public WriteStreamSubscriber<Buffer> toSubscriber()

      Specified by:
        `toSubscriber` in interface `WriteStream<Buffer>`

    - #### end

          public Future<Void> end​(Buffer data)

      Same as `end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### rxEnd

          public Completable rxEnd​(Buffer data)

      Same as `end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        `true` if write queue is full

    - #### pipe

          public Pipe<Buffer> pipe()

      Pause this stream and return a to transfer the elements of this stream to a destination .

      The stream will be resumed when the pipe will be wired to a `WriteStream`.
      Specified by:
        `pipe` in interface `ReadStream<Buffer>`
      Returns:
        a pipe

    - #### pipeTo

          public Future<Void> pipeTo​(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Specified by:
        `pipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the write stream will be ended with the outcome

    - #### rxPipeTo

          public Completable rxPipeTo​(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Specified by:
        `rxPipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the write stream will be ended with the outcome

    - #### exceptionHandler

          public SockJSSocket exceptionHandler​(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          public SockJSSocket handler​(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          public SockJSSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public SockJSSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          public SockJSSocket fetch​(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public SockJSSocket endHandler​(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### closeHandler

          public SockJSSocket closeHandler​(Handler<Void> closeHandler)

    - #### write

          public Future<Void> write​(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pipe`.

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### rxWrite

          public Completable rxWrite​(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pipe`.

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `rxWrite` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### write

          public Future<Void> write​(String data)

      Write a `String` to the socket, encoded in UTF-8.
      Parameters:
        `data` - the string to write
      Returns:

    - #### rxWrite

          public Completable rxWrite​(String data)

      Write a `String` to the socket, encoded in UTF-8.
      Parameters:
        `data` - the string to write
      Returns:

    - #### setWriteQueueMaxSize

          public SockJSSocket setWriteQueueMaxSize​(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public SockJSSocket drainHandler​(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeHandlerID

          public String writeHandlerID()

      When a `SockJSSocket` is created it can register an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

      Given this ID, a different event loop can send a buffer to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying socket. This allows you to write data to other sockets which are owned by different event loops.

      Returns:
        the `writeHandlerID` or `null` if `writeHandler` registration is disabled in `SockJSHandlerOptions`

    - #### end

          public Future<Void> end()

      Call `close()`.
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Returns:

    - #### rxEnd

          public Completable rxEnd()

      Call `close()`.
      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Returns:

    - #### close

          public void close()

      Close it

    - #### close

          public void close​(int statusCode,
                            String reason)

      Close it giving a status code and reason. Only Applicable to RawWebSocket will downgrade to plain close for other transports.
      Parameters:
        `statusCode` -
        `reason` -

    - #### remoteAddress

          public SocketAddress remoteAddress()

      Return the remote address for this socket
      Returns:

    - #### localAddress

          public SocketAddress localAddress()

      Return the local address for this socket
      Returns:

    - #### headers

          public MultiMap headers()

      Return the headers corresponding to the last request for this socket or the websocket handshake Any cookie headers will be removed for security reasons
      Returns:

    - #### uri

          public String uri()

      Return the URI corresponding to the last request for this socket or the websocket handshake
      Returns:

    - #### routingContext

          public RoutingContext routingContext()

      Returns:
        the Vert.x-Web RoutingContext corresponding to this socket

    - #### webSession

          public Session webSession()

      Returns:
        the Vert.x-Web session corresponding to this socket

    - #### webUser

          public User webUser()

      Returns:
        the Vert.x-Web user corresponding to this socket

    - #### newInstance

          public static SockJSSocket newInstance​(SockJSSocket arg)